Merge branch 'kd/stash-with-bash-4.4'
[git/git.git] / git-stash.sh
1 #!/bin/sh
2 # Copyright (c) 2007, Nanako Shiraishi
3
4 dashless=$(basename "$0" | sed -e 's/-/ /')
5 USAGE="list [<options>]
6 or: $dashless show [<stash>]
7 or: $dashless drop [-q|--quiet] [<stash>]
8 or: $dashless ( pop | apply ) [--index] [-q|--quiet] [<stash>]
9 or: $dashless branch <branchname> [<stash>]
10 or: $dashless save [--patch] [-k|--[no-]keep-index] [-q|--quiet]
11 [-u|--include-untracked] [-a|--all] [<message>]
12 or: $dashless [push [--patch] [-k|--[no-]keep-index] [-q|--quiet]
13 [-u|--include-untracked] [-a|--all] [-m <message>]
14 [-- <pathspec>...]]
15 or: $dashless clear"
16
17 SUBDIRECTORY_OK=Yes
18 OPTIONS_SPEC=
19 START_DIR=$(pwd)
20 . git-sh-setup
21 require_work_tree
22 prefix=$(git rev-parse --show-prefix) || exit 1
23 cd_to_toplevel
24
25 TMP="$GIT_DIR/.git-stash.$$"
26 TMPindex=${GIT_INDEX_FILE-"$(git rev-parse --git-path index)"}.stash.$$
27 trap 'rm -f "$TMP-"* "$TMPindex"' 0
28
29 ref_stash=refs/stash
30
31 if git config --get-colorbool color.interactive; then
32 help_color="$(git config --get-color color.interactive.help 'red bold')"
33 reset_color="$(git config --get-color '' reset)"
34 else
35 help_color=
36 reset_color=
37 fi
38
39 no_changes () {
40 git diff-index --quiet --cached HEAD --ignore-submodules -- "$@" &&
41 git diff-files --quiet --ignore-submodules -- "$@" &&
42 (test -z "$untracked" || test -z "$(untracked_files)")
43 }
44
45 untracked_files () {
46 if test "$1" = "-z"
47 then
48 shift
49 z=-z
50 else
51 z=
52 fi
53 excl_opt=--exclude-standard
54 test "$untracked" = "all" && excl_opt=
55 git ls-files -o $z $excl_opt -- "$@"
56 }
57
58 clear_stash () {
59 if test $# != 0
60 then
61 die "$(gettext "git stash clear with parameters is unimplemented")"
62 fi
63 if current=$(git rev-parse --verify --quiet $ref_stash)
64 then
65 git update-ref -d $ref_stash $current
66 fi
67 }
68
69 create_stash () {
70 stash_msg=
71 untracked=
72 while test $# != 0
73 do
74 case "$1" in
75 -m|--message)
76 shift
77 stash_msg=${1?"BUG: create_stash () -m requires an argument"}
78 ;;
79 -u|--include-untracked)
80 shift
81 untracked=${1?"BUG: create_stash () -u requires an argument"}
82 ;;
83 --)
84 shift
85 break
86 ;;
87 esac
88 shift
89 done
90
91 git update-index -q --refresh
92 if no_changes "$@"
93 then
94 exit 0
95 fi
96
97 # state of the base commit
98 if b_commit=$(git rev-parse --verify HEAD)
99 then
100 head=$(git rev-list --oneline -n 1 HEAD --)
101 else
102 die "$(gettext "You do not have the initial commit yet")"
103 fi
104
105 if branch=$(git symbolic-ref -q HEAD)
106 then
107 branch=${branch#refs/heads/}
108 else
109 branch='(no branch)'
110 fi
111 msg=$(printf '%s: %s' "$branch" "$head")
112
113 # state of the index
114 i_tree=$(git write-tree) &&
115 i_commit=$(printf 'index on %s\n' "$msg" |
116 git commit-tree $i_tree -p $b_commit) ||
117 die "$(gettext "Cannot save the current index state")"
118
119 if test -n "$untracked"
120 then
121 # Untracked files are stored by themselves in a parentless commit, for
122 # ease of unpacking later.
123 u_commit=$(
124 untracked_files -z "$@" | (
125 GIT_INDEX_FILE="$TMPindex" &&
126 export GIT_INDEX_FILE &&
127 rm -f "$TMPindex" &&
128 git update-index -z --add --remove --stdin &&
129 u_tree=$(git write-tree) &&
130 printf 'untracked files on %s\n' "$msg" | git commit-tree $u_tree &&
131 rm -f "$TMPindex"
132 ) ) || die "$(gettext "Cannot save the untracked files")"
133
134 untracked_commit_option="-p $u_commit";
135 else
136 untracked_commit_option=
137 fi
138
139 if test -z "$patch_mode"
140 then
141
142 # state of the working tree
143 w_tree=$( (
144 git read-tree --index-output="$TMPindex" -m $i_tree &&
145 GIT_INDEX_FILE="$TMPindex" &&
146 export GIT_INDEX_FILE &&
147 git diff-index --name-only -z HEAD -- "$@" >"$TMP-stagenames" &&
148 git update-index -z --add --remove --stdin <"$TMP-stagenames" &&
149 git write-tree &&
150 rm -f "$TMPindex"
151 ) ) ||
152 die "$(gettext "Cannot save the current worktree state")"
153
154 else
155
156 rm -f "$TMP-index" &&
157 GIT_INDEX_FILE="$TMP-index" git read-tree HEAD &&
158
159 # find out what the user wants
160 GIT_INDEX_FILE="$TMP-index" \
161 git add--interactive --patch=stash -- "$@" &&
162
163 # state of the working tree
164 w_tree=$(GIT_INDEX_FILE="$TMP-index" git write-tree) ||
165 die "$(gettext "Cannot save the current worktree state")"
166
167 git diff-tree -p HEAD $w_tree -- >"$TMP-patch" &&
168 test -s "$TMP-patch" ||
169 die "$(gettext "No changes selected")"
170
171 rm -f "$TMP-index" ||
172 die "$(gettext "Cannot remove temporary index (can't happen)")"
173
174 fi
175
176 # create the stash
177 if test -z "$stash_msg"
178 then
179 stash_msg=$(printf 'WIP on %s' "$msg")
180 else
181 stash_msg=$(printf 'On %s: %s' "$branch" "$stash_msg")
182 fi
183 w_commit=$(printf '%s\n' "$stash_msg" |
184 git commit-tree $w_tree -p $b_commit -p $i_commit $untracked_commit_option) ||
185 die "$(gettext "Cannot record working tree state")"
186 }
187
188 store_stash () {
189 while test $# != 0
190 do
191 case "$1" in
192 -m|--message)
193 shift
194 stash_msg="$1"
195 ;;
196 -q|--quiet)
197 quiet=t
198 ;;
199 *)
200 break
201 ;;
202 esac
203 shift
204 done
205 test $# = 1 ||
206 die "$(eval_gettext "\"$dashless store\" requires one <commit> argument")"
207
208 w_commit="$1"
209 if test -z "$stash_msg"
210 then
211 stash_msg="Created via \"git stash store\"."
212 fi
213
214 git update-ref --create-reflog -m "$stash_msg" $ref_stash $w_commit
215 ret=$?
216 test $ret != 0 && test -z "$quiet" &&
217 die "$(eval_gettext "Cannot update \$ref_stash with \$w_commit")"
218 return $ret
219 }
220
221 push_stash () {
222 keep_index=
223 patch_mode=
224 untracked=
225 stash_msg=
226 while test $# != 0
227 do
228 case "$1" in
229 -k|--keep-index)
230 keep_index=t
231 ;;
232 --no-keep-index)
233 keep_index=n
234 ;;
235 -p|--patch)
236 patch_mode=t
237 # only default to keep if we don't already have an override
238 test -z "$keep_index" && keep_index=t
239 ;;
240 -q|--quiet)
241 GIT_QUIET=t
242 ;;
243 -u|--include-untracked)
244 untracked=untracked
245 ;;
246 -a|--all)
247 untracked=all
248 ;;
249 -m|--message)
250 shift
251 test -z ${1+x} && usage
252 stash_msg=$1
253 ;;
254 --help)
255 show_help
256 ;;
257 --)
258 shift
259 break
260 ;;
261 -*)
262 option="$1"
263 # TRANSLATORS: $option is an invalid option, like
264 # `--blah-blah'. The 7 spaces at the beginning of the
265 # second line correspond to "error: ". So you should line
266 # up the second line with however many characters the
267 # translation of "error: " takes in your language. E.g. in
268 # English this is:
269 #
270 # $ git stash save --blah-blah 2>&1 | head -n 2
271 # error: unknown option for 'stash save': --blah-blah
272 # To provide a message, use git stash save -- '--blah-blah'
273 eval_gettextln "error: unknown option for 'stash save': \$option
274 To provide a message, use git stash save -- '\$option'"
275 usage
276 ;;
277 *)
278 break
279 ;;
280 esac
281 shift
282 done
283
284 eval "set $(git rev-parse --sq --prefix "$prefix" -- "$@")"
285
286 if test -n "$patch_mode" && test -n "$untracked"
287 then
288 die "$(gettext "Can't use --patch and --include-untracked or --all at the same time")"
289 fi
290
291 test -n "$untracked" || git ls-files --error-unmatch -- "$@" >/dev/null || exit 1
292
293 git update-index -q --refresh
294 if no_changes "$@"
295 then
296 say "$(gettext "No local changes to save")"
297 exit 0
298 fi
299
300 git reflog exists $ref_stash ||
301 clear_stash || die "$(gettext "Cannot initialize stash")"
302
303 create_stash -m "$stash_msg" -u "$untracked" -- "$@"
304 store_stash -m "$stash_msg" -q $w_commit ||
305 die "$(gettext "Cannot save the current status")"
306 say "$(eval_gettext "Saved working directory and index state \$stash_msg")"
307
308 if test -z "$patch_mode"
309 then
310 test "$untracked" = "all" && CLEAN_X_OPTION=-x || CLEAN_X_OPTION=
311 if test -n "$untracked"
312 then
313 git clean --force --quiet -d $CLEAN_X_OPTION -- "$@"
314 fi
315
316 if test $# != 0
317 then
318 git reset -q -- "$@"
319 git ls-files -z --modified -- "$@" |
320 git checkout-index -z --force --stdin
321 git clean --force -q -d -- "$@"
322 else
323 git reset --hard -q
324 fi
325
326 if test "$keep_index" = "t" && test -n "$i_tree"
327 then
328 git read-tree --reset $i_tree
329 git ls-files -z --modified -- "$@" |
330 git checkout-index -z --force --stdin
331 fi
332 else
333 git apply -R < "$TMP-patch" ||
334 die "$(gettext "Cannot remove worktree changes")"
335
336 if test "$keep_index" != "t"
337 then
338 git reset -q -- "$@"
339 fi
340 fi
341 }
342
343 save_stash () {
344 push_options=
345 while test $# != 0
346 do
347 case "$1" in
348 --)
349 shift
350 break
351 ;;
352 -*)
353 # pass all options through to push_stash
354 push_options="$push_options $1"
355 ;;
356 *)
357 break
358 ;;
359 esac
360 shift
361 done
362
363 stash_msg="$*"
364
365 if test -z "$stash_msg"
366 then
367 push_stash $push_options
368 else
369 push_stash $push_options -m "$stash_msg"
370 fi
371 }
372
373 have_stash () {
374 git rev-parse --verify --quiet $ref_stash >/dev/null
375 }
376
377 list_stash () {
378 have_stash || return 0
379 git log --format="%gd: %gs" -g --first-parent -m "$@" $ref_stash --
380 }
381
382 show_stash () {
383 ALLOW_UNKNOWN_FLAGS=t
384 assert_stash_like "$@"
385
386 if test -z "$FLAGS"
387 then
388 if test "$(git config --bool stash.showStat || echo true)" = "true"
389 then
390 FLAGS=--stat
391 fi
392
393 if test "$(git config --bool stash.showPatch || echo false)" = "true"
394 then
395 FLAGS=${FLAGS}${FLAGS:+ }-p
396 fi
397
398 if test -z "$FLAGS"
399 then
400 return 0
401 fi
402 fi
403
404 git diff ${FLAGS} $b_commit $w_commit
405 }
406
407 show_help () {
408 exec git help stash
409 exit 1
410 }
411
412 #
413 # Parses the remaining options looking for flags and
414 # at most one revision defaulting to ${ref_stash}@{0}
415 # if none found.
416 #
417 # Derives related tree and commit objects from the
418 # revision, if one is found.
419 #
420 # stash records the work tree, and is a merge between the
421 # base commit (first parent) and the index tree (second parent).
422 #
423 # REV is set to the symbolic version of the specified stash-like commit
424 # IS_STASH_LIKE is non-blank if ${REV} looks like a stash
425 # IS_STASH_REF is non-blank if the ${REV} looks like a stash ref
426 # s is set to the SHA1 of the stash commit
427 # w_commit is set to the commit containing the working tree
428 # b_commit is set to the base commit
429 # i_commit is set to the commit containing the index tree
430 # u_commit is set to the commit containing the untracked files tree
431 # w_tree is set to the working tree
432 # b_tree is set to the base tree
433 # i_tree is set to the index tree
434 # u_tree is set to the untracked files tree
435 #
436 # GIT_QUIET is set to t if -q is specified
437 # INDEX_OPTION is set to --index if --index is specified.
438 # FLAGS is set to the remaining flags (if allowed)
439 #
440 # dies if:
441 # * too many revisions specified
442 # * no revision is specified and there is no stash stack
443 # * a revision is specified which cannot be resolve to a SHA1
444 # * a non-existent stash reference is specified
445 # * unknown flags were set and ALLOW_UNKNOWN_FLAGS is not "t"
446 #
447
448 parse_flags_and_rev()
449 {
450 test "$PARSE_CACHE" = "$*" && return 0 # optimisation
451 PARSE_CACHE="$*"
452
453 IS_STASH_LIKE=
454 IS_STASH_REF=
455 INDEX_OPTION=
456 s=
457 w_commit=
458 b_commit=
459 i_commit=
460 u_commit=
461 w_tree=
462 b_tree=
463 i_tree=
464 u_tree=
465
466 FLAGS=
467 REV=
468 for opt
469 do
470 case "$opt" in
471 -q|--quiet)
472 GIT_QUIET=-t
473 ;;
474 --index)
475 INDEX_OPTION=--index
476 ;;
477 --help)
478 show_help
479 ;;
480 -*)
481 test "$ALLOW_UNKNOWN_FLAGS" = t ||
482 die "$(eval_gettext "unknown option: \$opt")"
483 FLAGS="${FLAGS}${FLAGS:+ }$opt"
484 ;;
485 *)
486 REV="${REV}${REV:+ }'$opt'"
487 ;;
488 esac
489 done
490
491 eval set -- $REV
492
493 case $# in
494 0)
495 have_stash || die "$(gettext "No stash entries found.")"
496 set -- ${ref_stash}@{0}
497 ;;
498 1)
499 :
500 ;;
501 *)
502 die "$(eval_gettext "Too many revisions specified: \$REV")"
503 ;;
504 esac
505
506 case "$1" in
507 *[!0-9]*)
508 :
509 ;;
510 *)
511 set -- "${ref_stash}@{$1}"
512 ;;
513 esac
514
515 REV=$(git rev-parse --symbolic --verify --quiet "$1") || {
516 reference="$1"
517 die "$(eval_gettext "\$reference is not a valid reference")"
518 }
519
520 i_commit=$(git rev-parse --verify --quiet "$REV^2") &&
521 set -- $(git rev-parse "$REV" "$REV^1" "$REV:" "$REV^1:" "$REV^2:" 2>/dev/null) &&
522 s=$1 &&
523 w_commit=$1 &&
524 b_commit=$2 &&
525 w_tree=$3 &&
526 b_tree=$4 &&
527 i_tree=$5 &&
528 IS_STASH_LIKE=t &&
529 test "$ref_stash" = "$(git rev-parse --symbolic-full-name "${REV%@*}")" &&
530 IS_STASH_REF=t
531
532 u_commit=$(git rev-parse --verify --quiet "$REV^3") &&
533 u_tree=$(git rev-parse "$REV^3:" 2>/dev/null)
534 }
535
536 is_stash_like()
537 {
538 parse_flags_and_rev "$@"
539 test -n "$IS_STASH_LIKE"
540 }
541
542 assert_stash_like() {
543 is_stash_like "$@" || {
544 args="$*"
545 die "$(eval_gettext "'\$args' is not a stash-like commit")"
546 }
547 }
548
549 is_stash_ref() {
550 is_stash_like "$@" && test -n "$IS_STASH_REF"
551 }
552
553 assert_stash_ref() {
554 is_stash_ref "$@" || {
555 args="$*"
556 die "$(eval_gettext "'\$args' is not a stash reference")"
557 }
558 }
559
560 apply_stash () {
561
562 assert_stash_like "$@"
563
564 git update-index -q --refresh || die "$(gettext "unable to refresh index")"
565
566 # current index state
567 c_tree=$(git write-tree) ||
568 die "$(gettext "Cannot apply a stash in the middle of a merge")"
569
570 unstashed_index_tree=
571 if test -n "$INDEX_OPTION" && test "$b_tree" != "$i_tree" &&
572 test "$c_tree" != "$i_tree"
573 then
574 git diff-tree --binary $s^2^..$s^2 | git apply --cached
575 test $? -ne 0 &&
576 die "$(gettext "Conflicts in index. Try without --index.")"
577 unstashed_index_tree=$(git write-tree) ||
578 die "$(gettext "Could not save index tree")"
579 git reset
580 fi
581
582 if test -n "$u_tree"
583 then
584 GIT_INDEX_FILE="$TMPindex" git read-tree "$u_tree" &&
585 GIT_INDEX_FILE="$TMPindex" git checkout-index --all &&
586 rm -f "$TMPindex" ||
587 die "$(gettext "Could not restore untracked files from stash entry")"
588 fi
589
590 eval "
591 GITHEAD_$w_tree='Stashed changes' &&
592 GITHEAD_$c_tree='Updated upstream' &&
593 GITHEAD_$b_tree='Version stash was based on' &&
594 export GITHEAD_$w_tree GITHEAD_$c_tree GITHEAD_$b_tree
595 "
596
597 if test -n "$GIT_QUIET"
598 then
599 GIT_MERGE_VERBOSITY=0 && export GIT_MERGE_VERBOSITY
600 fi
601 if git merge-recursive $b_tree -- $c_tree $w_tree
602 then
603 # No conflict
604 if test -n "$unstashed_index_tree"
605 then
606 git read-tree "$unstashed_index_tree"
607 else
608 a="$TMP-added" &&
609 git diff-index --cached --name-only --diff-filter=A $c_tree >"$a" &&
610 git read-tree --reset $c_tree &&
611 git update-index --add --stdin <"$a" ||
612 die "$(gettext "Cannot unstage modified files")"
613 rm -f "$a"
614 fi
615 squelch=
616 if test -n "$GIT_QUIET"
617 then
618 squelch='>/dev/null 2>&1'
619 fi
620 (cd "$START_DIR" && eval "git status $squelch") || :
621 else
622 # Merge conflict; keep the exit status from merge-recursive
623 status=$?
624 git rerere
625 if test -n "$INDEX_OPTION"
626 then
627 gettextln "Index was not unstashed." >&2
628 fi
629 exit $status
630 fi
631 }
632
633 pop_stash() {
634 assert_stash_ref "$@"
635
636 if apply_stash "$@"
637 then
638 drop_stash "$@"
639 else
640 status=$?
641 say "$(gettext "The stash entry is kept in case you need it again.")"
642 exit $status
643 fi
644 }
645
646 drop_stash () {
647 assert_stash_ref "$@"
648
649 git reflog delete --updateref --rewrite "${REV}" &&
650 say "$(eval_gettext "Dropped \${REV} (\$s)")" ||
651 die "$(eval_gettext "\${REV}: Could not drop stash entry")"
652
653 # clear_stash if we just dropped the last stash entry
654 git rev-parse --verify --quiet "$ref_stash@{0}" >/dev/null ||
655 clear_stash
656 }
657
658 apply_to_branch () {
659 test -n "$1" || die "$(gettext "No branch name specified")"
660 branch=$1
661 shift 1
662
663 set -- --index "$@"
664 assert_stash_like "$@"
665
666 git checkout -b $branch $REV^ &&
667 apply_stash "$@" && {
668 test -z "$IS_STASH_REF" || drop_stash "$@"
669 }
670 }
671
672 test "$1" = "-p" && set "push" "$@"
673
674 PARSE_CACHE='--not-parsed'
675 # The default command is "push" if nothing but options are given
676 seen_non_option=
677 for opt
678 do
679 case "$opt" in
680 --) break ;;
681 -*) ;;
682 *) seen_non_option=t; break ;;
683 esac
684 done
685
686 test -n "$seen_non_option" || set "push" "$@"
687
688 # Main command set
689 case "$1" in
690 list)
691 shift
692 list_stash "$@"
693 ;;
694 show)
695 shift
696 show_stash "$@"
697 ;;
698 save)
699 shift
700 save_stash "$@"
701 ;;
702 push)
703 shift
704 push_stash "$@"
705 ;;
706 apply)
707 shift
708 apply_stash "$@"
709 ;;
710 clear)
711 shift
712 clear_stash "$@"
713 ;;
714 create)
715 shift
716 create_stash -m "$*" && echo "$w_commit"
717 ;;
718 store)
719 shift
720 store_stash "$@"
721 ;;
722 drop)
723 shift
724 drop_stash "$@"
725 ;;
726 pop)
727 shift
728 pop_stash "$@"
729 ;;
730 branch)
731 shift
732 apply_to_branch "$@"
733 ;;
734 *)
735 case $# in
736 0)
737 push_stash &&
738 say "$(gettext "(To restore them type \"git stash apply\")")"
739 ;;
740 *)
741 usage
742 esac
743 ;;
744 esac